-- Main.lua
-- Originally written by Rod, extended by Habna


import "Turbine.Gameplay";
import "HabnaPlugins.HugeBag";

Version = "1.2.30c"; --> ** HugeBag current version **
RDate = "Nov, 3th 2011"; --> ** HugeBag release date **

local Modesettings = {};
Modesettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagMode" );

-- **v no setting found, so save it v**
if Modesettings == nil then
	Modesettings = {};
	Modesettings.Widget = true;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Load Settings v**
Widget = Modesettings.Widget;
-- **^

import "HabnaPlugins.HugeBag.GlobalVariable"; -- LUA GlobalVariable file
import "HabnaPlugins.HugeBag.functionsBoth"; -- LUA functions file for both mode
import "HabnaPlugins.HugeBag.color"; -- LUA color file
import "HabnaPlugins.HugeBag.sortingList"; -- LUA sorting list file
import "HabnaPlugins.HugeBag.sort"; -- LUA Sort file
import "HabnaPlugins.HugeBag.search"; -- LUA Search file
import "HabnaPlugins.HugeBag.merge"; -- LUA Merge file
import "HabnaPlugins.HugeBag.buttonmenu"; -- LUA Button Menu file
import "HabnaPlugins.HugeBag.swappablelist"; -- LUA swappable list file

if ( Widget ) then
	import "HabnaPlugins.HugeBag.MainWidget";
else
	import "HabnaPlugins.HugeBag.MainWindow";
end

frmMain = frmMain();

HugeBagCommand = Turbine.ShellCommand();

function HugeBagCommand:Execute( command, arguments )
	if ( Widget ) then
		if ( arguments == "show" ) then
			ShowHugeBag();
		elseif ( arguments == "hide" ) then
			HideHugeBag();
		--[[
		elseif ( arguments == "unload" ) then
			--UnloadHugeBag();
		elseif ( arguments == "reload" ) then
			--ReloadHugeBag();
		]]
		elseif ( arguments == "resetall" ) then
			ResetSettings();
		elseif ( arguments == "wesc" ) then
			ToggleWEsc();
		elseif ( arguments == "visible" ) then
			ToggleShow();
		elseif ( arguments == "mode" ) then
			ToggleWidgetMode();
		elseif ( arguments == "aot" or arguments == "alwaysontop" ) then
			ToggleAlwaysOnTop();
		elseif ( arguments == "sort" ) then
			Sort();
		elseif ( arguments == "merge" ) then
			Merge();
		elseif ( arguments == "about" ) then
			ShowAbout();
		elseif ( arguments == "help" or arguments == "?" ) then
			HelpInfo();
		elseif ( arguments == "add" ) then
			Add();
		else
			write( "HugeBag: Command not supported" );
		end
	else
		if ( arguments == "show" ) then
			ShowHugeBag();
		elseif ( arguments == "hide" ) then
			HideHugeBag();
		--[[
		elseif ( arguments == "unload" ) then
			UnloadHugeBag();
		elseif ( arguments == "reload" ) then
			ReloadHugeBag();
		]]
		elseif ( arguments == "resetls" ) then
			ResetLSSettings();
		elseif ( arguments == "resetall" ) then
			ResetSettings();
		elseif ( arguments == "wesc" ) then
			ToggleWEsc();
		elseif ( arguments == "visible" ) then
			ToggleShow();
		elseif ( arguments == "mode" ) then
			ToggleWidgetMode();
		elseif ( arguments == "slots" ) then
			ToggleSlotsInfo();
		elseif ( arguments == "used" ) then
			ToggleFreeUsed();
		elseif ( arguments == "skin" ) then
			ToggleSkin();
		elseif ( arguments == "aot" or arguments == "alwaysontop" ) then
			ToggleAlwaysOnTop();
		elseif ( arguments == "orientation" ) then
			ToggleItemsOrientation();
		--[[ Disabled until i found a way to reverse the scrollbar in the same orientation (Top goes to bottom, bottom goes to top)
		elseif ( arguments == "reversefill" ) then
			ToggleItemsReverseFill();
		]]
		elseif ( arguments == "options" ) then
			frmOptions();
		elseif ( arguments == "locksize" ) then
			LockHugeBagSize();
		elseif ( arguments == "lockpos" or arguments == "lockposition") then
			LockHugeBagPosition();
		elseif ( arguments == "sort" ) then
			Sort();
		elseif ( arguments == "merge" ) then
			Merge();
		elseif ( arguments == "about" ) then
			ShowAbout();
		elseif ( arguments == "help" or arguments == "?") then
			HelpInfo();
		elseif ( arguments == "add" ) then
			Add();
		else
			write( "HugeBag: Command not supported" );
		end
	end
end

Turbine.Shell.AddCommand( "HugeBag", HugeBagCommand );

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );

Turbine.Plugin.Unload = function( self, sender, args )
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, true );

	Turbine.PluginManager.UnloadScriptState( "HugeBagUtilities" );
end