-- functions.lua
-- Written By Habna


-- **v Hide HugeBag v**
function ShowHugeBag()
	if ( frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already visible" );
	else
		frmMain:SetVisible( true );
		--write( "HugeBag: I'm now visible" );
	end
end
-- **^
-- **v Hide HugeBag v**
function HideHugeBag()
	if ( not frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already hidden" );
	else
		frmMain:SetVisible( false );
		--write( "HugeBag: I'm now hidden" );
	end
end
-- **^
-- **v Show Settings window v**
function ShowCurrentSettings()
	import "HabnaPlugins.HugeBag.contextMenu"; -- LUA contextual menu file
	contextMenu();
end
-- **^
-- **v Toggle Slots Info to show free or used slots v**
function ToggleFreeUsed()
	ToggleUsed = ( not ToggleUsed );
	SaveSettings();
	frmMain:PrintTitle();
	--[[
	if ( ToggleUsed ) then
		write( "HugeBag: Now showing used slots informations in the title" );
	else
		write( "HugeBag: Now showing free slots informations in the title" );
	end
	]]
end
-- **^
-- **v Toggle Slots Info v**
function ToggleSlotsInfo()
	ShowSlotsInfo = ( not ShowSlotsInfo );
	SaveSettings();
	frmMain:PrintTitle();
	--[[
	if ( ShowSlotsInfo ) then
		write( "HugeBag: Now showing slots informations in the title" );
	else
		write( "HugeBag: Not showing slots informations in the title" );
	end
	]]
end
-- **^
-- **v Toggle Items Orientation v**
function ToggleItemsOrientation()
	HorizontalOrientation = ( not HorizontalOrientation );
	frmMain:PerformLayout();
	SaveSettings();
end
-- **^
--[[ Disabled until i found a way to reverse the scrollbar in the same orientation (Top goes to bottom, bottom goes to top)
-- **v Toggle Items ReverseFill v**
function ToggleItemsReverseFill()
	ReverseFill = ( not ReverseFill );
	frmMain.itemListBox:SetReverseFill( ReverseFill );
	frmMain:PerformLayout();
	SaveSettings();
end
-- **^
]]
-- **v Lock HugeBag Position v**
function LockHugeBagSize()
	LockSize = ( not LockSize );
	SaveSettings();
	--[[
	if ( LockSize ) then
		write( "HugeBag: My size is now lock." );
	else
		write( "HugeBag: My size is now unlock." );
	end
	]]
end
-- **^
-- **v Lock HugeBag Position v**
function LockHugeBagPosition()
	LockPosition = ( not LockPosition );
	LockLabel.Enable = not LockPosition;
	SaveSettings();
	--[[
	if ( LockPosition ) then
		--write( "HugeBag: My position is now lock." );
	else
		--write( "HugeBag: My position is now unlock." );
	end
	]]
end
-- **^
-- **v Move all buttons to left side of window v**
function ButtonsLeft()
	if not ButtonAtLeft then
		Diff = MidPos - 85;
		LeftPos, MidPos, RightPos = 35, 85, 135;
		SortLeft = SortLeft - Diff;
		SearchLeft = SearchLeft - Diff;
		MergeLeft = MergeLeft - Diff;
		if ( ButtonAtTop ) then
			TopPos = 22;
		else
			TopPos = WinHeight - 13;
		end
		SortButton:SetPosition( SortLeft,  TopPos ); --> ** Replace 'Sort' button with HugeBag height **
		SearchButton:SetPosition( SearchLeft,  TopPos ); --> ** Replace 'Search' button with HugeBag height **
		MergeButton:SetPosition( MergeLeft, TopPos ); --> ** Replace 'Merge' button with HugeBag height **
		SearchInput:SetPosition( SortLeft,  TopPos - 7 ); --> ** Replace 'Search Box' with HugeBag height **
		ButtonAtLeft = true;
		SaveSettings();
	end
end
-- **^
-- **v Move all buttons to right side of window v**
function ButtonsRight()
	if ButtonAtLeft then
		Diff = ( WinWidth - 185 ) - LeftPos;
		LeftPos = ( WinWidth - 185 );
		MidPos = LeftPos + 50;
		RightPos = MidPos + 50;
		SortLeft = SortLeft + Diff;
		SearchLeft = SearchLeft + Diff;
		MergeLeft = MergeLeft + Diff;
		if ( ButtonAtTop ) then
			TopPos = 22;
		else
			TopPos = WinHeight - 13;
		end
		SortButton:SetPosition( SortLeft,  TopPos ); --> ** Replace 'Sort' button with HugeBag height **
		SearchButton:SetPosition( SearchLeft,  TopPos ); --> ** Replace 'Search' button with HugeBag height **
		MergeButton:SetPosition( MergeLeft, TopPos ); --> ** Replace 'Merge' button with HugeBag height **
		SearchInput:SetPosition( SortLeft,  TopPos - 7 ); --> ** Replace 'Search Box' with HugeBag height **
		ButtonAtLeft = false;
		SaveSettings();
	end
end
-- **^
-- **v Options List v**
function LoadListOptionsName()
	OptionNameList = {};
	OptionNameList[1]= "Show slots info in title: ";
	OptionNameList[2]= "Slots info to show in title: ";
	OptionNameList[3]= "Start visible at startup: ";
	OptionNameList[4]= "Hide HugeBag when 'esc' key is press: ";
	OptionNameList[5]= "Size locker activated: ";
	OptionNameList[6]= "Position locker activated: ";
	OptionNameList[7]= "HugeBag mode: ";
	OptionNameList[8]= "Show HugeBag skin: ";
	OptionNameList[9]= "Orientation of items: ";
	--OptionNameList[10]= "Reverse fill the items: ";
	OptionNameList[10]= "HugeBag always on top: ";
end
-- **^
-- **v Shell command List v**
function LoadShellCommandName()
	ShellCommandName = {};
	ShellCommandName[1]= "show";
	ShellCommandName[2]= "hide";
	ShellCommandName[3]= "unload";
	ShellCommandName[4]= "reload";
	ShellCommandName[5]= "resetls";
	ShellCommandName[6]= "resetall";
	ShellCommandName[7]= "wesc";
	ShellCommandName[8]= "visible";
	ShellCommandName[9]= "mode";
	ShellCommandName[10]= "slots";
	ShellCommandName[11]= "used";
	ShellCommandName[12]= "skin";
	ShellCommandName[13]= "aot";
	ShellCommandName[14]= "orientation";
	--ShellCommandName[15]= "reversefill";
	ShellCommandName[15]= "options";
	ShellCommandName[16]= "locksize";
	ShellCommandName[17]= "lockpos";
	ShellCommandName[18]= "sort"
	ShellCommandName[19]= "merge"
	ShellCommandName[20]= "about";
	ShellCommandName[21]= "help/?";
end
-- **^
-- **v Shell Command description list v**
function LoadShellCommandDes()
	ShellCommandDes = {};
	ShellCommandDes[1]= "Show HugeBag";
	ShellCommandDes[2]= "Hide HugeBag";
	ShellCommandDes[3]= "Unload HugeBag (NOT WORKING, Turbine API Issues)";
	ShellCommandDes[4]= "Reload HugeBag (NOT WORKING, Turbine API Issues)";
	ShellCommandDes[5]= "Reset location and size settings to default";
	ShellCommandDes[6]= "Reset all settings to default";
	ShellCommandDes[7]= "Toggle hide HugeBag event when the 'esc' key is press";
	ShellCommandDes[8]= "Show or hide HugeBag at startup";
	ShellCommandDes[9]= "Toggle between widget and window mode";
	ShellCommandDes[10]= "Show or hide slots information in title";
	ShellCommandDes[11]= "Toggle to show free or used slots info in title";
	ShellCommandDes[12]= "Toggle HugeBag skin on and off";
	ShellCommandDes[13]= "Toggle HugeBag ability to be always on top are not";
	ShellCommandDes[14]= "Toggle items oriention";
	--ShellCommandDes[15]= "Toggle reverse fill of items (NOT WORKING)";
	ShellCommandDes[15]= "Show HugeBag Options";
	ShellCommandDes[16]= "Lock/unlock HugeBag size";
	ShellCommandDes[17]= "Lock/unlock HugeBag position";
	ShellCommandDes[18]= "Sort HugeBag items (Courtesy of MrJackdaw)"
	ShellCommandDes[19]= "Merge stackable items into one stack item"
	ShellCommandDes[20]= "Show the 'About' window";
	ShellCommandDes[21]= "Show HugeBag shell commands/?";
end