-- options.lua
-- Written by Habna


import "HabnaPlugins.HugeBag.skin"; -- LUA Button Menu file

function frmOptions()
	self = Turbine.UI.Lotro.Window();
	--self = Turbine.UI.Lotro.GoldWindow();
	
	-- **v Set backcolor, position, size and text of the window v**
	NumOptions = 16; --> Total number of options (white + green)
	NumOptTop = 10; --> Number of options in the top section (White options)

	self:SetSize( 360, (NumOptions * 20 + 60) );
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
	local winWidth, winHeight = self:GetSize();
	local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight /2 );
    self:SetPosition( left, top );
	self:SetText( "HugeBag Options" );
	self:SetBackColor( Turbine.UI.Color() );
	self:SetVisible( true );
	--self:SetZOrder( 2 );
	self:Activate();
	-- **^

	LoadListOptionsName()

	--**v Options Label v**
	local PosY = 40;
	for i = 1, NumOptTop do
		local label1q = Turbine.UI.Label();
		label1q:SetParent( self );
		label1q:SetText( OptionNameList[i] );
		label1q:SetPosition( 15, PosY );
		label1q:SetSize( self:GetWidth(), 18 );
		label1q:SetForeColor( white );
		label1q:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		PosY = PosY + 20;
	end
	--**^
	--**v Show slots info in title v**
	local OptR1lbl = Turbine.UI.Label();
	OptR1lbl:SetParent( self );
	OptR1lbl:SetText( tostring( ShowSlotsInfo ) );
	OptR1lbl:SetPosition( 200, 40 );
	OptR1lbl:SetSize(35, 18 );
	OptR1lbl:SetForeColor( green );
	OptR1lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR1lbl.MouseClick = function(sender, args)
		ToggleSlotsInfo();
		OptR1lbl:SetText( tostring( ShowSlotsInfo ) );
	end

	OptR1lbl.MouseHover = function(sender, args)
		OptR1lbl:SetBackColor( lightgrey );
		OptR1lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR1lbl.MouseLeave = function(sender, args)
		OptR1lbl:SetBackColor( none );
	end
	--**^
	--**v Slots info to show in title v**
	local OptR2lbl = Turbine.UI.Label();
	OptR2lbl:SetParent( self );
	if ToggleUsed then
		OptR2lbl:SetText( "used slots info" );
	else
		OptR2lbl:SetText( "free slots info" );
	end
	OptR2lbl:SetPosition( 220, 60 );
	OptR2lbl:SetSize(110, 18 );
	OptR2lbl:SetForeColor( green );
	OptR2lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR2lbl.MouseClick = function(sender, args)
		ToggleFreeUsed();
		if ToggleUsed then
			OptR2lbl:SetText( "used slots info" );
		else
			OptR2lbl:SetText( "free slots info" );
		end
	end

	OptR2lbl.MouseHover = function(sender, args)
		OptR2lbl:SetBackColor( lightgrey );
		OptR2lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR2lbl.MouseLeave = function(sender, args)
		OptR2lbl:SetBackColor( none );
	end
	--**^
	--**v Start visible at startup v**
	local OptR3lbl = Turbine.UI.Label();
	OptR3lbl:SetParent( self );
	OptR3lbl:SetText( tostring( StartVisible ) );
	OptR3lbl:SetPosition( 200, 80 );
	OptR3lbl:SetSize(35, 18 );
	OptR3lbl:SetForeColor( green );
	OptR3lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR3lbl.MouseClick = function(sender, args)
		ToggleShow();
		OptR3lbl:SetText( tostring( StartVisible ) );
	end

	OptR3lbl.MouseHover = function(sender, args)
		OptR3lbl:SetBackColor( lightgrey );
		OptR3lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR3lbl.MouseLeave = function(sender, args)
		OptR3lbl:SetBackColor( none );
	end
	--**^
	--**v Hide HugeBag when 'esc' key is press v**
	local OptR4lbl = Turbine.UI.Label();
	OptR4lbl:SetParent( self );
	OptR4lbl:SetText( tostring( HideWEsc ) );
	OptR4lbl:SetPosition( 285, 100 );
	OptR4lbl:SetSize(35, 18 );
	OptR4lbl:SetForeColor( green );
	OptR4lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR4lbl.MouseClick = function(sender, args)
		ToggleWEsc();
		OptR4lbl:SetText( tostring( HideWEsc ) );
	end

	OptR4lbl.MouseHover = function(sender, args)
		OptR4lbl:SetBackColor( lightgrey );
		OptR4lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR4lbl.MouseLeave = function(sender, args)
		OptR4lbl:SetBackColor( none );
	end
	--**^
	--**v Size locker activated v**
	local OptR5lbl = Turbine.UI.Label();
	OptR5lbl:SetParent( self );
	OptR5lbl:SetText( tostring( LockSize ) );
	OptR5lbl:SetPosition( 175, 120 );
	OptR5lbl:SetSize(35, 18 );
	OptR5lbl:SetForeColor( green );
	OptR5lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR5lbl.MouseClick = function(sender, args)
		LockHugeBagSize();
		OptR5lbl:SetText( tostring( LockSize ) );
	end

	OptR5lbl.MouseHover = function(sender, args)
		OptR5lbl:SetBackColor( lightgrey );
		OptR5lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR5lbl.MouseLeave = function(sender, args)
		OptR5lbl:SetBackColor( none );
	end
	--**^
	--**v Position locker activated v**
	local OptR6lbl = Turbine.UI.Label();
	OptR6lbl:SetParent( self );
	OptR6lbl:SetText( tostring( LockPosition ) );
	OptR6lbl:SetPosition( 205, 140 );
	OptR6lbl:SetSize(35, 18 );
	OptR6lbl:SetForeColor( green );
	OptR6lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR6lbl.MouseClick = function(sender, args)
		LockHugeBagPosition();
		OptR6lbl:SetText( tostring( LockPosition ) );
	end

	OptR6lbl.MouseHover = function(sender, args)
		OptR6lbl:SetBackColor( lightgrey );
		OptR6lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR6lbl.MouseLeave = function(sender, args)
		OptR6lbl:SetBackColor( none );
	end
	--**^
	--**v widget mode v**
	local OptR7lbl = Turbine.UI.Label();
	OptR7lbl:SetParent( self );
	if ( Widget ) then
		OptR7lbl:SetText( "widget mode" );
	else
		OptR7lbl:SetText( "window mode" );
	end
	OptR7lbl:SetPosition( 115, 160 );
	OptR7lbl:SetSize(80, 18 );
	OptR7lbl:SetForeColor( green );
	OptR7lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR7lbl.MouseClick = function(sender, args)
		ToggleWidgetMode();
		self:Close();
	end

	OptR7lbl.MouseHover = function(sender, args)
		OptR7lbl:SetBackColor( lightgrey );
		OptR7lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR7lbl.MouseLeave = function(sender, args)
		OptR7lbl:SetBackColor( none );
	end
	--**^
	--**v Show HugeBag skin v**
	local OptR8lbl = Turbine.UI.Label();
	OptR8lbl:SetParent( self );
	OptR8lbl:SetText( tostring( ShowSkin ) );
	OptR8lbl:SetPosition( 150, 180 );
	OptR8lbl:SetSize(35, 18 );
	OptR8lbl:SetForeColor( green );
	OptR8lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR8lbl.MouseClick = function(sender, args)
		ToggleSkin();
		OptR8lbl:SetText( tostring( ShowSkin ) );
	end

	OptR8lbl.MouseHover = function(sender, args)
		OptR8lbl:SetBackColor( lightgrey );
		OptR8lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR8lbl.MouseLeave = function(sender, args)
		OptR8lbl:SetBackColor( none );
	end
	--**^
	--**v Orientation of items v**
	local OptR9lbl = Turbine.UI.Label();
	OptR9lbl:SetParent( self );
	OptR9lbl:SetText( "Vertical" );
	if HorizontalOrientation then OptR9lbl:SetText( "Horizontal" ); end
	OptR9lbl:SetPosition( 175, 200 );
	OptR9lbl:SetSize(70, 18 );
	OptR9lbl:SetForeColor( green );
	OptR9lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR9lbl.MouseClick = function(sender, args)
		ToggleItemsOrientation();
		OptR9lbl:SetText( "Vertical" );
		if HorizontalOrientation then OptR9lbl:SetText( "Horizontal" ); end
	end

	OptR9lbl.MouseHover = function(sender, args)
		OptR9lbl:SetBackColor( lightgrey );
		OptR9lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR9lbl.MouseLeave = function(sender, args)
		OptR9lbl:SetBackColor( none );
	end
	--**^
	--[[ Disabled until i found a way to reverse the scrollbar in the same orientation (Top goes to bottom, bottom goes to top)
	--**v Reverse Fill of items v**
	local OptR10lbl = Turbine.UI.Label();
	OptR10lbl:SetParent( self );
	OptR10lbl:SetText( tostring( ReverseFill ) );
	OptR10lbl:SetPosition( 185, 220 );
	OptR10lbl:SetSize(35, 18 );
	OptR10lbl:SetForeColor( green );
	OptR10lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR10lbl.MouseClick = function(sender, args)
		ToggleItemsReverseFill();
		OptR10lbl:SetText( tostring( ReverseFill ) );
	end

	OptR10lbl.MouseHover = function(sender, args)
		OptR10lbl:SetBackColor( lightgrey );
		OptR10lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR10lbl.MouseLeave = function(sender, args)
		OptR10lbl:SetBackColor( none );
	end
	--**^
	]]
	--**v Always on top v**
	local OptR11lbl = Turbine.UI.Label();
	OptR11lbl:SetParent( self );
	if zOrder then
		OptR11lbl:SetText( "true" );
	else
		OptR11lbl:SetText( "false" );
	end
	OptR11lbl:SetPosition( 180, 220 );
	OptR11lbl:SetSize(35, 18 );
	OptR11lbl:SetForeColor( green );
	OptR11lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR11lbl.MouseClick = function(sender, args)
		ToggleAlwaysOnTop();
		OptR11lbl:SetText( tostring( zOrder ) );
	end

	OptR11lbl.MouseHover = function(sender, args)
		OptR11lbl:SetBackColor( lightgrey );
		OptR11lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR11lbl.MouseLeave = function(sender, args)
		OptR11lbl:SetBackColor( none );
	end
	--**^
	--**v Show free, used and max slots in shell v**
	local OptR100lbl = Turbine.UI.Label();
	OptR100lbl:SetParent( self );
	OptR100lbl:SetText( "Show HugeBag shell commands" );
	OptR100lbl:SetPosition( 15, PosY );
	OptR100lbl:SetSize(195, 18 );
	OptR100lbl:SetForeColor( green );
	OptR100lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR100lbl.MouseClick = function(sender, args)
		HelpInfo();
	end

	OptR100lbl.MouseHover = function(sender, args)
		OptR100lbl:SetBackColor( lightgrey );
		OptR100lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR100lbl.MouseLeave = function(sender, args)
		OptR100lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Reset Location and size settings to default v**
	local OptR101lbl = Turbine.UI.Label();
	OptR101lbl:SetParent( self );
	OptR101lbl:SetText( "Reset Location and size settings to default" );
	OptR101lbl:SetPosition( 15, PosY );
	OptR101lbl:SetSize(310, 18 );
	OptR101lbl:SetForeColor( green );
	OptR101lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR101lbl.MouseClick = function(sender, args)
		ResetLSSettings();
		self:Close();
	end

	OptR101lbl.MouseHover = function(sender, args)
		OptR101lbl:SetBackColor( lightgrey );
		OptR101lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR101lbl.MouseLeave = function(sender, args)
		OptR101lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Reset all settings to default v**
	local OptR102lbl = Turbine.UI.Label();
	OptR102lbl:SetParent( self );
	OptR102lbl:SetText( "Reset all settings to default" );
	OptR102lbl:SetPosition( 15, PosY );
	OptR102lbl:SetSize(210, 18 );
	OptR102lbl:SetForeColor( green );
	OptR102lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR102lbl.MouseClick = function(sender, args)
		ResetSettings();
		self:Close();
	end

	OptR102lbl.MouseHover = function(sender, args)
		OptR102lbl:SetBackColor( lightgrey );
		OptR102lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR102lbl.MouseLeave = function(sender, args)
		OptR102lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Set HugeBag background color v**
	local OptR105lbl = Turbine.UI.Label();
	OptR105lbl:SetParent( self );
	OptR105lbl:SetText( "Set HugeBag background color" );
	OptR105lbl:SetPosition( 15, PosY );
	OptR105lbl:SetSize(200, 18 );
	OptR105lbl:SetForeColor( green );
	OptR105lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR105lbl.MouseClick = function(sender, args)
		SetBackgroundColor();
	end

	OptR105lbl.MouseHover = function(sender, args)
		OptR105lbl:SetBackColor( lightgrey );
		OptR105lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR105lbl.MouseLeave = function(sender, args)
		OptR105lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v About HugeBag v**
	local OptR106lbl = Turbine.UI.Label();
	OptR106lbl:SetParent( self );
	OptR106lbl:SetText( "Add/Remove Swappable Item" );
	OptR106lbl:SetPosition( 15, PosY );
	OptR106lbl:SetSize(180, 18 );
	OptR106lbl:SetForeColor( green );
	OptR106lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR106lbl.MouseClick = function(sender, args)
		Add();
	end

	OptR106lbl.MouseHover = function(sender, args)
		OptR106lbl:SetBackColor( lightgrey )
		OptR106lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end

	OptR106lbl.MouseLeave = function(sender, args)
		OptR106lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v About HugeBag v**
	local OptR199lbl = Turbine.UI.Label();
	OptR199lbl:SetParent( self );
	OptR199lbl:SetText( "About HugeBag" );
	OptR199lbl:SetPosition( 15, PosY );
	OptR199lbl:SetSize(95, 18 );
	OptR199lbl:SetForeColor( green );
	OptR199lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR199lbl.MouseClick = function(sender, args)
		ShowAbout();
	end

	OptR199lbl.MouseHover = function(sender, args)
		OptR199lbl:SetBackColor( lightgrey );
		OptR199lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR199lbl.MouseLeave = function(sender, args)
		OptR199lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Reload Message v**
	local Reloadlbl = Turbine.UI.Label();
	Reloadlbl:SetParent( self );
	Reloadlbl:SetText( "* : Reloading HugeBag required" );
	Reloadlbl:SetPosition( 35, PosY );
	Reloadlbl:SetSize( 300, 18 );
	Reloadlbl:SetForeColor( red );
	Reloadlbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^

	--**v Red dot - Start visible v**
	local RedDotLbl1 = Turbine.UI.Label();
	RedDotLbl1:SetParent( self );
	RedDotLbl1:SetText( "*" );
	RedDotLbl1:SetPosition( 6, 83 );
	RedDotLbl1:SetForeColor( red );
	--**^
	--**v Red dot - HugeBag mode v**
	local RedDotLbl2 = Turbine.UI.Label();
	RedDotLbl2:SetParent( self );
	RedDotLbl2:SetText( "*" );
	RedDotLbl2:SetPosition( 6, 163 );
	RedDotLbl2:SetForeColor( red );
	--**^
	--**v Red dot - Always on top v**
	local RedDotLbl3 = Turbine.UI.Label();
	RedDotLbl3:SetParent( self );
	RedDotLbl3:SetText( "*" );
	RedDotLbl3:SetPosition( 6, 223 );
	RedDotLbl3:SetForeColor( red );
	--**^
	
	-- **v Set the opacity when the mouse enter the window v**
	self.MouseEnter = function( sender, args )
		self:SetOpacity( 1.0 );
	end
	-- **^
	-- **v Set the opacity when the mouse leave the window v**
	self.MouseLeave = function( sender, args )
		self:SetOpacity( 1.0 );
	end

	self.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			self:SetVisible(false);
		end
	end
	-- **^
end
-- **^