-- settingsWidget.lua
-- Written by Habna


-- **v Load settings v**
function LoadSettings()
	settings = {};
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWidgetSettings" );

	-- **v no settings found, create it v**
	if settings == nil then
		WinLocX = screenWidth - WinWidth;
		WinLocY = screenHeight - WinHeight - 70;
		SaveSettings();
	end
	-- **^
	-- **v Load Settings v**
	if settings.Location == nil then
		settings.Location = {};
		settings.Location.X = screenWidth - WinWidth;
		settings.Location.Y = screenHeight - WinHeight - 70;
		settings.Location.Loc = "right";
	else
		if settings.Location.X == nil then
			settings.Location.X = screenWidth - WinWidth;
		end
		if settings.Location.Y == nil then
			settings.Location.Y = screenHeight - WinHeight - 70;
		end
		if settings.Location.Loc == nil then
			settings.Location.Loc = "right";
		end
	end

	WinLocX = settings.Location.X;
	WinLocY = settings.Location.Y;
	WidgetLoc = settings.Location.Loc;

	-- **v Replace HugeBag if out of the screen on load v**
	if ( WinLocY + WinHeight ) > screenHeight then WinLocY = screenHeight - WinHeight end
	-- **^

	if settings.BackColor == nil then
		settings.BackColor = {};
		settings.BackColor.A = bcAlpha;
		settings.BackColor.R = bcRed;
		settings.BackColor.G = bcGreen;
		settings.BackColor.B = bcBlue;
	else
		if settings.BackColor.A == nil then
			settings.BackColor.A = bcAlpha;
		end
		if settings.BackColor.R == nil then
			settings.BackColor.R = bcRed;
		end
		if settings.BackColor.G == nil then
			settings.BackColor.G = bcGreen;
		end
		if settings.BackColor.B == nil then
			settings.BackColor.B = bcBlue;
		end
	end

	bcAlpha = settings.BackColor.A;
	bcRed = settings.BackColor.R;
	bcGreen = settings.BackColor.G;
	bcBlue = settings.BackColor.B;

	if settings.Options == nil then
		settings.Options = {};
		settings.Options.StartVisible = StartVisible;
		settings.Options.HideWEsc = HideWEsc;
		settings.Options.AlwaysOnTop = zOrder;
	else
		if settings.Options.StartVisible == nil then
			settings.Options.StartVisible = StartVisible;
		end
		if settings.Options.HideWEsc == nil then
			settings.Options.HideWEsc = HideWEsc;
		end
		if settings.Options.AlwaysOnTop == nil then
			settings.Options.AlwaysOnTop = zOrder;
		end
	end

	StartVisible = settings.Options.StartVisible;
	HideWEsc = settings.Options.HideWEsc;
	zOrder = settings.Options.AlwaysOnTop;

	if settings.ButtonPos == nil then
		settings.ButtonPos = {};
		settings.ButtonPos.AtLeft = ButtonAtLeft;
		settings.ButtonPos.MidPos = MidPos;
		settings.ButtonPos.Sort = SortLeft;
		settings.ButtonPos.Search = SearchLeft;
		settings.ButtonPos.Merge = MergeLeft;
	else
		if settings.ButtonPos.AtLeft == nil then
			settings.ButtonPos.AtLeft = ButtonAtLeft;
		end
		if settings.ButtonPos.MidPos == nil then
			settings.ButtonPos.MidPos = MidPos;
		end
		if settings.ButtonPos.Sort == nil then
			settings.ButtonPos.Sort = SortLeft;
		end
		if settings.ButtonPos.Search == nil then
			settings.ButtonPos.Search = SearchLeft;
		end
		if settings.ButtonPos.Merge == nil then
			settings.ButtonPos.Merge = MergeLeft;
		end
	end

	ButtonAtLeft = settings.ButtonPos.AtLeft;
	MidPos = settings.ButtonPos.MidPos;
	SortLeft = settings.ButtonPos.Sort;
	SearchLeft = settings.ButtonPos.Search;
	MergeLeft = settings.ButtonPos.Merge;
	
	if settings.Version == nil then
		settings.Version = Version;
	end

	if settings.WidgetLoc == nil then
		settings.WidgetLoc = right;
	else
		settings.WidgetLoc = WidgetLoc;
	end

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettings", settings );
	-- **^

	tsettings = {};
	tsettings = Turbine.PluginData.Load( Turbine.DataScope.Server, "HugeBagSwappableSettings" );
	
	if tsettings == nil then tsettings = tCatHB; end
	
	ttable = tsettings; -- temporary table with user category
	
	-- merge/insert HugeBag table into user temporary table
	--for k, v in ipairs(tCatHB) do table.insert( ttable, v ); end (CRASH CLIENT)
	for i = 1, #tCatHB do table.insert( ttable, tCatHB[i] ); end

	-- Sort temporary table by it's key (not descending)
	table.sort( ttable );

	-- Copy value from temporary table to tCat and skip duplicate entry
	table.RemoveDuplicate();
	
	tsettings = tCat; -- Set the newly merge, sorted and duplicate free table to tsettings

	Turbine.PluginData.Save( Turbine.DataScope.Server, "HugeBagSwappableSettings", tsettings );
end
-- **^

function SaveSwappableSettings()
	tsettings = tCat;
	Turbine.PluginData.Save( Turbine.DataScope.Server, "HugeBagSwappableSettings", tsettings );
end

-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;

	settings.Options = {};
	settings.Options.StartVisible = StartVisible;
	if HBW then settings.Options.StartVisible = true; end
	settings.Options.HideWEsc = HideWEsc;

	settings.Location = {};
	settings.Location.X = WinLocX;
	settings.Location.Y = WinLocY;
	settings.Location.Loc = WidgetLoc;

	settings.BackColor = {};
	settings.BackColor.A = bcAlpha;
	settings.BackColor.R = bcRed;
	settings.BackColor.G = bcGreen;
	settings.BackColor.B = bcBlue;

	settings.ButtonPos = {};
	settings.ButtonPos.AtLeft = ButtonAtLeft;
	settings.ButtonPos.MidPos = MidPos;
	settings.ButtonPos.Sort = SortLeft;
	settings.ButtonPos.Search = SearchLeft;
	settings.ButtonPos.Merge = MergeLeft;
	settings.Options.AlwaysOnTop = zOrder;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettings", settings );

	Modesettings = {};
	Modesettings.Widget = Widget;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	WinLocX = screenWidth - WinWidth - 1;
	WinLocY = screenHeight - WinHeight - 69;
	frmMain:SetPosition( WinLocX, WinLocY );
	WidgetLoc = "right";
	StartVisible = false;
	HideWEsc = true;
	Widget = Widget;
	bcAlpha, bcRed, bcGreen, bcBlue = 0.3, 0.3, 0.3, 0.3;
	frmMain.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	if ( windowOpen ) and ( not StartVisible ) then
		frmMain:SetVisible( true );
		slideCtr:SetWantsUpdates(true);
	end
	ButtonAtLeft = true;
	ButtonsPos = "left";
	LeftPos, MidPos, RightPos = 5, 55, 105;
	SortLeft, SearchLeft, MergeLeft = LeftPos, MidPos, RightPos;
	SortButton:SetPosition( SortLeft,  8 );
	SearchButton:SetPosition( SearchLeft,  8 );
	MergeButton:SetPosition( MergeLeft, 8 );
	zOrder = false;
	SaveSettings();
	write( "HugeBag: All my settings was set back to default" );
end
-- **^
--^ FUNCTIONS/METHODS SECTION ^--